#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <engine>
#include <hamsandwich>


#include <speedspeed>
#include <cursorInterface>
#include <GothicMod>
#include <GothicMod_Util>
#include <GothicMod_DBManager>
#include <GothicMod_Stats&Reqs>

#define PLUGIN "Gothic Mod - Lodowa Pulapka"
#define VERSION "1.0.0"
#define AUTHOR "R3X"

#define TASKID 9656783214

new const gszClass[] = "Lodowa Pulapka";
//new const gszModel[] = "sprites/GM/sprite1e.spr";
new const gszModel[] = "sprites/GM/sprite2.5a.spr";
new const Float:gfFrameRate = 10.0;

#if MATRIX_SIZE  == 5
new giPattern[] = {
	0, 0, 0, 0, 1,
	0, 0, 0, 0, 1,
	0, 0, 1, 1, 1,
	0, 0, 0, 0, 0,
	0, 0, 0, 0, 0
};
#else
	#if MATRIX_SIZE == 3
		new giPattern[] = {
			0, 0, 1, 
			0, 1, 1, 
			0, 0, 0
		};
	#else
		#assert "Niepoprawny wzorzec ruchu"
	#endif
#endif

new giInCaster[33];
new giEnt[33];

new giEntPublic[512];
new CsTeams:giEntTeam[512];
new CsTeams:giPlayerTeam[33];

new Float:fSpeedOffset[33];

new Float:gfLastSlowDown[33];

public plugin_init(){
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	register_forward(FM_TraceLine, "fwTraceLine", 1);
	register_forward(FM_AddToFullPack, "fwAddToFullPack", 1);
	register_touch(gszClass, "player", "fwPlayerTouch");
	register_touch(gszClass, "grenade", "fwGrenadeTouch");
	
	RegisterHam(Ham_Spawn, "player", "fwSpawn");
	
	register_event("TeamInfo", "eventTeamInfo", "a");
	
}

public plugin_precache(){
	precache_model(gszModel);
}

public fwSpawn(id){
	if(task_exists(id+TASKID))
		remove_task(id+TASKID);
		
	fSpeedOffset[id] = 0.0;
	if(is_user_alive(id)){
		update_user_speed(id);
	}
}
public fwPlayerTouch(ent, id){
	if(is_user_alive(id) && fm_is_ent_reachable(ent, id)){
		if(giPlayerTeam[id] == giEntTeam[ent]) return;
		
		new Float:fNow = get_gametime();
		if( floatabs(gfLastSlowDown[id] - fNow) > 10.0){
			gfLastSlowDown[id] = fNow;
			
			fSpeedOffset[id] = -200.0;
			update_user_speed(id);
			
			giEntPublic[ent] = 1;
			new data[1];
			data[0] = ent;
			set_task( 8.0, "TASK_ClearSlowDown", id+TASKID, data, 1);
		}
	}
}
public fwGrenadeTouch(ent, grenade){
	giEntPublic[ent] = 1;
	
	if(!task_exists(TASKID)){
		new data[1];
		data[0] = ent;
		set_task( 8.0, "TASK_ClearSlowDown", TASKID, data, 1);
	}
}
public TASK_ClearSlowDown(data[], id){
	id -= TASKID;

	fSpeedOffset[id] = 0.0;
	if(is_user_alive(id)){
		update_user_speed(id);
	}
	
	giEntPublic[data[0]] = 0;
}

new cid;
public client_putinserver(id){
	giInCaster[id] = 0;
}
public fwOnRegisterReady(){
	cid = register_caster(forAssasin, "Lodowa Pulapka", "Ustaw pulapke zamrazajaca wroga", 5, getPatternLength(giPattern), 1);
	
	setHelpImage(cid, "2P.gif");//do plikow pomocy moze sie przydac, ale pewnie nie bedzie tego w finalu
}

public caster_requrements(){
	//{BRON, ZABIC, HS?}
	//add_requirement(cid, {GROUP_RIFLES, 5, 0});
}
public fwOnCheckPattern(id, const iPath[]){	
	//wzor nie pasuje
	if(!areEqualPaths(giPattern, iPath)) 
		return PATTERN_DIFFERENT;
		
	if(check_user_duration(id, cid, 5.0) == 0.0 	//minetlo 5.0sekund od ostatniego uzycia
	&& drain_user_mana(id, 5)){ 
		callCaster(id);	//wiec boom!
	}
		
	return PATTERN_EQUAL;
}
callCaster(id){
	giInCaster[id] = 1;
	set_mana_reneneration(id, 100.0);
	set_user_status(id, TRIGGER_STATUS);
	
	giEnt[id] = createSprite(id);
	giEntTeam[giEnt[id]] = cs_get_user_team(id);
}
createSprite(id){
	new ent = create_entity("env_sprite");
	
	set_pev(ent, pev_classname, gszClass);
	
	entity_set_size(ent, Float:{-1.0, -1.0, -1.0}, Float:{1.0, 1.0, 1.0});
	set_rendering(ent, kRenderFxNone, 255, 255, 255, kRenderTransAdd, 255);
	entity_set_model( ent, gszModel);
	
	set_pev(ent, pev_scale, 1.0);
	set_pev(ent, pev_owner, id);
	set_pev(ent, pev_framerate, gfFrameRate );
	
	entity_set_size(ent, Float:{-4.0, -4.0, 0.0}, Float:{4.0, 4.0, 3.0});
	DispatchSpawn(ent);
	
	set_pev(ent, pev_movetype, MOVETYPE_NOCLIP);
	set_pev(ent, pev_solid, SOLID_NOT);
	
	return ent;
}
executeCaster(id){
	giInCaster[id] = 0;
	set_mana_reneneration(id);
	
	set_pev(giEnt[id], pev_solid, SOLID_TRIGGER);

	unlock_caster(id);
	reset_user_status(id);
	return GM_HANDLED;
}
public trigger_caster(id){
	if(giInCaster[id]){
		return executeCaster(id);
	}
	return GM_CONTINUE;		
}
public fwCleanUp(){
	/*
	for(new i=1;i<512; i++){
		giEntTeam[i] = CS_TEAM_UNASSIGNED;
		giEntPublic[i] = 0;
	}
		
	remove_entity_name(gszClass);
	*/
}

public unlock_forced(id){
	giInCaster[id] = 0;
}


public fwAddToFullPack(es_handle, e, ent, host, flags, id, set){
	if(!giEntPublic[ent] && giEntTeam[ent] &&  giEntTeam[ent] != giPlayerTeam[host]){
		set_es(es_handle, ES_Origin, Float:{0.0, 0.0, 0.0});
		set_es(es_handle, ES_RenderAmt, 0);
		return FMRES_HANDLED;
	}
	return FMRES_IGNORED;
}
//Aktualizuje szybkosc gracza
public speed_update(id, wid){
	add_user_speed(id, fSpeedOffset[id]);
}

public fwTraceLine(const Float:v1[], const Float:v2[], fNoMonsters, id, ptr){
	if(is_user_alive(id) && giInCaster[id]){
		static Float:vfOrigin[3];
		get_tr2(ptr, TR_vecEndPos, vfOrigin);
		
		static Float:vfNormal[3];
		static Float:vfNormal2[3];
		get_tr2(ptr, TR_vecPlaneNormal, vfNormal);
		
		xs_vec_copy(vfNormal, vfNormal2);
		xs_vec_mul_scalar(vfNormal2, 0.1, vfNormal2);
		xs_vec_add(vfOrigin, vfNormal, vfOrigin);
		
		vfNormal[0] *= -1.0;
		vfNormal[1] *= -1.0;
		
		vector_to_angle(vfNormal, vfNormal);
		
		set_pev(giEnt[id], pev_angles, vfNormal);
		set_pev(giEnt[id], pev_origin, vfOrigin);
	}
}

public eventTeamInfo(){
	new id = read_data(1);
	
	new szTeam[2];
	read_data(2, szTeam, 1);
	
	switch(szTeam[0]){
		case 'C': giPlayerTeam[id] = CS_TEAM_CT;
		case 'T': giPlayerTeam[id] = CS_TEAM_T;
		default :  giPlayerTeam[id] = CS_TEAM_UNASSIGNED;
	}
}
