#include <amxmodx>
#include <amxmisc>
#include <fakemeta_util>
#include <cstrike>
#include <engine>
#include <nvault>

#define PLUGIN_NAME "Czas gry + block CT"
#define PLUGIN_VERSION "2.0"
#define PLUGIN_AUTHOR "Del"
enum
{
    CS_TEAM_UNASSIGNED = 0,
    CS_TEAM_T,
    CS_TEAM_CT,
    CS_TEAM_SPECTATOR
}
#define INFO 672
#define OFFSET_TEAM  114 
#define cs_get_user_team(%1)     get_pdata_int( %1, OFFSET_TEAM ) 

#define OFFSET_DEATHS  444
#define cs_get_user_deaths(%1)     get_pdata_int( %1, OFFSET_DEATHS )
#define cs_set_user_deaths(%1,%2)  set_pdata_int( %1, OFFSET_DEATHS, %2 )

new mChooseTeam
new czas_graczy;
new SyncHudObj;


new nazwa_gracza[33][64];
new czas_gracza[33];
new awaryjny_gracza[33];
new test[33];
new czasgry;
new gmsgHideWeapon;


public plugin_init() {
	register_plugin(PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR);
	
	czas_graczy = nvault_open("czas");
	register_message(get_user_msgid("ShowMenu"), "message_show_menu");
	register_event("ResetHUD", "set_hud", "be");
	register_concmd("czas_info", "InformacjeGraczy", ADMIN_KICK, "- Wyswietla informacje o graczach(czas)")
	register_concmd("amx_dodaj", "KomendaDodajPrawoCT", ADMIN_IMMUNITY, "- <nick> <wartosc> (0 wylacza)")
	register_concmd("ustaw_czas", "KomendaUstawCzas", ADMIN_IMMUNITY, "- <nick> <wartosc>")
	
	czasgry = register_cvar("jb_czas","600");
	SyncHudObj = CreateHudSyncObj();
	gmsgHideWeapon = get_user_msgid("HideWeapon")
	
	register_clcmd("chooseteam", "cmdBlock");

	createMenu();

	return PLUGIN_CONTINUE;
}

public ZapiszCzas(id)
{
	new vaultkey[64],vaultdata[256];
	format(vaultkey,63,"%s-Czas", nazwa_gracza[id]);
	format(vaultdata,255,"%i#%i#%i", czas_gracza[id],awaryjny_gracza[id],test[id]);
	nvault_set(czas_graczy,vaultkey,vaultdata);
}

public WczytajCzas(id)
{
	new vaultkey[64],vaultdata[256];
	format(vaultkey,63,"%s-Czas", nazwa_gracza[id]);
	format(vaultdata,255,"%i#%i#%i", czas_gracza[id],awaryjny_gracza[id],test[id]);
	nvault_get(czas_graczy,vaultkey,vaultdata,255);
 
	replace_all(vaultdata, 255, "#", " ");
 
	new czasgracza[32], awaryjnygracza[32], testt[32];
 
	parse(vaultdata, czasgracza, 31, awaryjnygracza, 31, testt, 31);
 
	czas_gracza[id] = str_to_num(czasgracza);
	awaryjny_gracza[id] = str_to_num(awaryjnygracza)
	test[id] = str_to_num(testt);
}

public client_connect(id)
{
	get_user_name(id, nazwa_gracza[id], 63);
	set_user_info(id, "_vgui_menus", "0");
	remove_task(id+INFO);
	WczytajCzas(id);
	set_task(3.0, "PokazInformacje", id+INFO);

	return PLUGIN_CONTINUE;
}
public client_disconnect(id)
{
	czas_gracza[id]=czas_gracza[id]+(get_user_time(id)/60);
	ZapiszCzas(id)
}


public set_hud(id) {
	//showMsg = 0;

	set_task(0.2, "fixHUD", id);
	set_task(0.3, "fadeOut", id);

	return PLUGIN_CONTINUE;
}

public fixHUD(id) {
	if (!user_has_weapon(id, CSW_KNIFE))
	{
		fm_set_user_suit(id);
		fm_give_item(id, "weapon_knife");
	}

	return PLUGIN_CONTINUE;
}

public fadeOut()
{
	client_cmd(0, "cd fadeout");
	return PLUGIN_CONTINUE;
}
public cmdBlock(id)
{
	menu_display(id, mChooseTeam, 0);
	return PLUGIN_HANDLED;
}

// custom menu
public createMenu() {
	mChooseTeam = menu_create("Wybierz Team", "mh_ChooseTeam");
	menu_additem(mChooseTeam, "Wiezniowie", "ma_ChooseTeam", ADMIN_ALL);
	menu_additem(mChooseTeam, "Klawisze^n", "ma_ChooseTeam", ADMIN_ALL);
	menu_additem(mChooseTeam, "Spectator", "ma_ChooseTeam", ADMIN_ALL);
	return PLUGIN_CONTINUE;
}


public message_show_menu(msgid, dest, id) {
	if (get_user_team(id) || task_exists(id))
		return PLUGIN_CONTINUE;

	static team_select[] = "#Team_Select";
	static menu_text_code[sizeof team_select];

	get_msg_arg_string(4, menu_text_code, sizeof menu_text_code - 1);

	if (!equal(menu_text_code, team_select))
		return PLUGIN_CONTINUE;

	set_task(0.1, "force_team_join", id);

	return PLUGIN_HANDLED;
}

public force_team_join(id) {
	engclient_cmd(id, "jointeam", "6");
	menu_display(id, mChooseTeam, 0);

	return PLUGIN_CONTINUE;
}

public mh_ChooseTeam(id, menu, item) { 
	new warunek[33]
	if(czas_gracza[id] < get_pcvar_num(czasgry))
	{
		warunek[id]=1
	}
	if(awaryjny_gracza[id]!=0)
	{
		warunek[id]=0
	}	
	switch (item)
	{
		case -3: return PLUGIN_HANDLED;

		case 0:
			if (cs_get_user_team(id) == CS_TEAM_T)
				return PLUGIN_HANDLED;
		
		case 1: {
			if (cs_get_user_team(id) == CS_TEAM_CT)
				{
				return PLUGIN_HANDLED;
				}
			if(warunek[id]==1)
					{
					client_print(id, print_chat,"Nie spelniasz warunkow wejscia do CT");
					return PLUGIN_HANDLED;
					}
			}

		case 2:
			if (cs_get_user_team(id) == CS_TEAM_SPECTATOR)
				return PLUGIN_HANDLED;
	}	

	if (cs_get_user_team(id) != CS_TEAM_SPECTATOR)
	{
		user_silentkill(id);
		cs_set_user_deaths(id, cs_get_user_deaths(id) - 1);
		draw_crosshair(id) 
	}

	cs_set_user_team(id, item + 1, random_num(1, 5));

	new Players[32], playerCount;
	get_players(Players, playerCount, "c");

	if (playerCount == 1)
		server_cmd("sv_restart 1");

	return PLUGIN_HANDLED;
}

//info
public PokazInformacje(id) 
{
	id -= INFO;
	
	set_task(0.1, "PokazInformacje", id+INFO);
		
	if(!is_user_alive(id))
	{
		if(!is_valid_ent(id))
		return PLUGIN_CONTINUE;
		new target = entity_get_int(id, EV_INT_iuser2);
		
		if(target == 0)
			return PLUGIN_CONTINUE;
	
		set_hudmessage(60, 60, 255, 0.02, 0.87, 1, 0.0, 0.3, 0.0, 0.0);
		ShowSyncHudMsg(id, SyncHudObj, "Czas Gracza : %i minut ",czas_gracza[target]+(get_user_time(target)/60));
		
		return PLUGIN_CONTINUE;
	}
	set_hudmessage(60, 255, 60, 0.02, 0.87, 1, 0.0, 0.3, 0.0, 0.0);
	ShowSyncHudMsg(id, SyncHudObj, "Twoj czas na serwerze: %i min",czas_gracza[id]+(get_user_time(id)/60));
	return PLUGIN_CONTINUE;
}  

public InformacjeGraczy(id, level, cid)
{
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED
	
	new players[32], lgraczy, name[32];
	get_players(players, lgraczy)
	console_print(id, "======================================================");
	console_print(id, "= Nick | Ilosc Minut | Prawo nadane  przez admina");
	console_print(id, "==================================================");
	
	for (new a = 0; a < lgraczy; ++a)
	{
		new plr = players[a];
		if(!is_user_connected(plr) || is_user_hltv(plr)|| is_user_bot(plr))
			continue;
		
		get_user_name(plr, name, 31)
		WczytajCzas(plr);
		console_print(id," %s | %i | %i |",name, czas_gracza[plr]+(get_user_time(plr)/60), awaryjny_gracza[plr]);
	}
	console_print(id, "===================================");
	
	return PLUGIN_HANDLED
}

public KomendaDodajPrawoCT(id, level, cid)
{
	if(!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED;
	
	new arg1[33];
	new arg2[6];
	read_argv(1, arg1, 32);
	read_argv(2, arg2, 5);
	new gracz  = cmd_target(id, arg1, 0);
	new ilosc = str_to_num(arg2);
	WczytajCzas(gracz);		
	awaryjny_gracza[gracz]=ilosc;
	ZapiszCzas(gracz);
	return PLUGIN_HANDLED;
}
public KomendaUstawCzas(id, level, cid)
{
	if(!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED;
	
	new arg1[33];
	new arg2[6];
	read_argv(1, arg1, 32);
	read_argv(2, arg2, 5);
	new gracz  = cmd_target(id, arg1, 0);
	new ilosc = str_to_num(arg2);
	WczytajCzas(gracz);		
	czas_gracza[gracz]=ilosc;
	ZapiszCzas(gracz);
	return PLUGIN_HANDLED;
}
draw_crosshair(id) 
{ 
    message_begin(MSG_ONE_UNRELIABLE, gmsgHideWeapon, _, id) 
    write_byte(0) 
    message_end() 
} 
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
