#include <amxmodx>
#include <amxmisc>
#include <ColorChat>
#include <fakemeta>
#include <hamsandwich>
#include <basebuilder>
#include <cstrike>

#include <fun>

#define PLUGIN	"Grupy"
#define AUTHOR	"Spalony"
#define VERSION	"1.0"

#define MAX 32

enum userInformation {
	bool: isInGroup ,
	groupID,
	groupColor
}

new userInf[ MAX + 1 ][ userInformation ];

new groupUsed[ MAX + 1 ];

new currentColor = 0;

new pCvarMAX , pCvarMinimum;

new userEnt[ MAX + 1 ];

new bool: bSlap = false,
	bool: bBuild = false;

#define SetLastMover(%1,%2)     ( set_pev( %1, pev_iuser4, %2 ) )

#define FLAG ADMIN_LEVEL_H
#define MAXENTS 1024

new pAdmin,pInfo,pInfoText;

new const serverIP[] = "31.186.82.130:27331";

new colorNames[][] = {
	 "Czerwony",
        "Zielony",
        "Bialy",
        "Zolty",
        "Pomaranczowy",
        "Niebieski",
        "Fioletowy",
        "Jaskrawo-Rozowy",
        "Brazowy",
        "Szary"
}

new colorRGB[][ 3 ] = {
	{200, 000, 000},
	{000, 150, 000},
	{255, 255, 255},
	{252, 232, 131},
	{255, 117, 056},
	{000, 000, 255},
	{146, 110, 174},
	{255, 105, 180},
	{180, 103, 077},
	{149, 145, 140}
}

new amountRender = 50;

public plugin_init(){
	
	new szIp[ 33 ];
	get_user_ip( 0, szIp, charsmax( szIp ) );
	
	if( !equal( szIp , serverIP ) ){
		server_print("IP nieprawidlowe");
		set_fail_state("Plugin nie dziala na tym serwerze.");
	}
	
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	pCvarMAX		=	register_cvar( "group_max_number" , "2" );
	pCvarMinimum	=	register_cvar( "group_min_players_amount" , "8" );
	
	RegisterHam( Ham_Touch , "func_wall" , "fwTouch" , 1 );
	RegisterHam( Ham_TakeDamage , "player" , "fwTakeDamage" , 0 );
	RegisterHam( Ham_TraceAttack , "player" , "fwTraceAttack" , 0 );
	RegisterHam( Ham_Spawn , "player" , "fwSpawned" , 1 );
	
	register_clcmd( "say /grupy" , "menuGrupa" );
	register_clcmd( "say /grupa" , "menuGrupa" );
	register_clcmd( "say_team /grupy" , "menuGrupa" );
	register_clcmd( "say_team /grupa" , "menuGrupa" );
	
	register_event("DeathMsg", "DeathMsg", "a");
	
	register_logevent( "roundEnd", 2, "1=Round_End");
	
	pAdmin = register_cvar("bb_one_admin","0");
	pInfo = register_cvar("bb_one_info","1");
	pInfoText = register_cvar("bb_one_text","Obiekt nalezy juz do %s");
	
	//register_forward(FM_AddToFullPack, "fwAddToFullPack", 0 );
}

/*public fwAddToFullPack(es_handle, e, ENT, HOST, hostflags, player, set){
if(!player || !is_user_alive( ENT ) || !bBuild ) return FMRES_IGNORED;

if( !checkIsIn( ENT , userInf[ HOST ][ groupID ] ) ){
return FMRES_IGNORED;
}

set_es( es_handle , ES_RenderMode , kRenderNormal );
set_es( es_handle , ES_RenderFx , kRenderFxGlowShell );
set_es( es_handle , ES_RenderColor , Float: { 255.0 , 0.0 , 0.0 } );
set_es( es_handle , ES_RenderAmt , 5.0 );

return FMRES_HANDLED;
}*/

public roundEnd(){
	
	clearAllGroups();
	
	return PLUGIN_CONTINUE;
}

clearAllGroups(){
	for( new iCurrent = 0 ; iCurrent <= MAX ; iCurrent++ ){
		groupUsed[ iCurrent ]	=	false;
		
		userInf[ iCurrent ][ isInGroup ]	=	false;
		userInf[ iCurrent ][ groupID ]		=	-1;
		userInf[ iCurrent ][ groupColor ]	=	-1;
		
		if( is_user_connected( iCurrent ) ){
			set_user_rendering(  iCurrent , kRenderFxNone , 255 , 255 , 255 , kRenderNormal , 255 );
		}
	}
	
	currentColor = 0;
}

public bb_buildphase_started(){
	bBuild = true;
}

public bb_round_started(){
	bSlap = false;
	bBuild = false;
}

public fwTraceAttack( this, idattacker, Float:damage, Float:direction[3], tracehandle, damagebits ){
	return checkDmg( this , idattacker );
}

public fwTakeDamage( this, idinflictor, idattacker, Float:damage, damagebits){
	return checkDmg( this , idattacker );
}

public fwSpawned( id ){
	if( !is_user_alive( id ) ){
		return HAM_IGNORED;
	}
	
	if( !userInf[ id ][ isInGroup ] ){
		return HAM_IGNORED;
	}
	
	if( bb_is_user_zombie( id ) ){
		set_user_rendering( id , kRenderFxNone , 255 , 255 , 255 , kRenderNormal , 255 );
		
		return HAM_IGNORED;
	}
	
	new iColor = userInf[ id ][ groupColor ];
	
	set_user_rendering( id , kRenderFxGlowShell , colorRGB[ iColor ][ 0 ] , colorRGB[ iColor ][ 1 ] , colorRGB[ iColor ][ 2 ] , kRenderNormal , amountRender );
	
	return HAM_IGNORED;
}

checkDmg( this , idattacker ){
	if( !is_user_alive( idattacker ) || !is_user_connected( this ) ){
		return HAM_IGNORED;
	}
	
	if( !bb_is_user_zombie( this ) ){
		return HAM_IGNORED;
	}
	
	if( checkISOnGround( idattacker ) ){
		if( checkISOnGround( this ) ){
			return HAM_IGNORED;
		}
	}
	
	if( checkISOnlyOneCamp() ){
		return HAM_IGNORED;
	}
	
	new groundEntity = pev( this , pev_groundentity );
	
	if( checkISOnGround( this ) ){
		return HAM_SUPERCEDE;
	}
	
	if( pev_valid( groundEntity ) ){
		
		new idUser = pev( groundEntity , pev_iuser4 );
		
		if( idUser != idattacker && !checkIsIn( idattacker , userInf[ idUser ][ groupID ] ) ){
			return HAM_SUPERCEDE;
		}
	}
	else if( pev_valid( userEnt[ this ] ) ){
		
		new idUser = pev( userEnt[ this ] , pev_iuser4 );
		
		if( idUser != idattacker && !checkIsIn( idattacker , userInf[ idUser ][ groupID ] ) ){
			return HAM_SUPERCEDE;
		}
	}
	
	return HAM_IGNORED;
}

bool: checkISOnGround( id ){
	new groundEntity = pev( id , pev_groundentity );
	
	new szTarget[ 16 ];
	
	if( pev_valid( groundEntity ) ){
		pev( groundEntity , pev_targetname , szTarget , charsmax( szTarget ) );
		
		if( equal( szTarget , "ignore" ) || equal( szTarget , "barrier" ) || !bb_is_used_block( groundEntity ) ){
			return true;
		}
	}
	else if( pev_valid( userEnt[ id ] ) ){
		pev( userEnt[ id ] , pev_targetname , szTarget , charsmax( szTarget ) );
		
		if( equal( szTarget , "ignore" ) || equal( szTarget , "barrier" ) || !bb_is_used_block( userEnt[ id ] ) ){
			return true;
		}
	}
	
	return ( !pev_valid( userEnt[ id ] ) && !pev_valid( groundEntity ) )
}

bool:checkISOnlyOneCamp(){
	
	new bool: tmpGroupUsed[ MAX + 1 ];
	
	new iAmount = 0;
	
	for( new iPlayer = 1 ; iPlayer < MAX + 1 ; iPlayer++ ){
		if( !is_user_alive( iPlayer ) || bb_is_user_zombie( iPlayer ) ){
			continue;
		}
		
		if( !userInf[ iPlayer ][ isInGroup ] ){
			iAmount++;
		}
		else if( !tmpGroupUsed[ userInf[ iPlayer ][ groupID ] ] ){
			tmpGroupUsed[ userInf[ iPlayer ][ groupID ] ] = true;
			
			iAmount++;
		}
	}
	
	return iAmount <= 1;
}

public client_PreThink( id ){
	if( !is_user_alive( id ) ){
		return PLUGIN_CONTINUE;
	}
	
	if( pev( id , pev_groundentity ) != 0 ){
		userEnt[ id ] = pev( id , pev_groundentity );
		
		remove_task( id );
		
		set_task( 0.5 , "clearEnt" , id );
	}
	
	return PLUGIN_CONTINUE;
}

public clearEnt( id ){
	userEnt[ id ] = 0;
}

public fwTouch( iEnt , idToucher ){
	if( !bSlap || !pev_valid( iEnt ) || !pev_valid( idToucher ) || !is_user_alive( idToucher ) || bb_is_user_zombie( idToucher ) ){
		return HAM_IGNORED
	}
	
	new szTarget[ 16 ];
	
	pev( iEnt , pev_targetname , szTarget , charsmax( szTarget ) );
	
	if( equal( szTarget , "ignore" ) || equal( szTarget , "barrier" ) || !bb_is_used_block( iEnt ) ){
		return HAM_IGNORED;
	}
	
	new idUser	=	pev( iEnt , pev_iuser4 );
	
	if( idUser == idToucher ){
		return HAM_IGNORED;
	}
	
	if( userInf[ idUser ][ isInGroup ] ){
		if( checkIsIn( idToucher , userInf[ idUser ][ groupID ] ) ){
			return HAM_IGNORED;
		}
	}
	
	user_slap( idToucher , 0 , 1 );
	
	return HAM_IGNORED;
}

public client_connect( id ){
	
	userEnt[ id ]	=	0;
	
	userInf[ id ][ groupID ]	=	-1;
	userInf[ id ][ isInGroup ]	=	false;
	userInf[ id ][ groupColor ]	=	-1;
	
}

public client_disconnect( id ){
	
	checkBlocks( id );
	
	clearUserInf( id );
	
}

public opuscGrupa( id ){
	
	if( !userInf[ id ][ isInGroup ] ) {
		
		ColorChat(id,RED,"[ GRUPY ] - ^x01Opusciles^x04 Grupe^x01" );
		
		return PLUGIN_HANDLED;
		
	}
	
	clearUserInf( id );
	
	return PLUGIN_HANDLED;
	
}

public menuGrupa( id ){
	
	if( !bBuild ){
		return PLUGIN_CONTINUE;
	}
	
	if( bb_is_user_zombie( id ) ){
		
		ColorChat(id,RED,"[ GRUPY ] - ^x01Zombi nie moze uzywac^x04 grup^x01" ); 		
		return PLUGIN_HANDLED;
	}
	
	if( !checkAmountPlayer( get_pcvar_num( pCvarMinimum ) ) ){
		
		ColorChat(id,RED,"[ GRUPY ] - ^x01Jest zbyt malo graczy, musi byc minimum^x04 %d^x01" , get_pcvar_num( pCvarMinimum ) );
		
		return PLUGIN_HANDLED;
		
	}
	
	if( userInf[ id ][ isInGroup ] && !checkGroupSize( userInf[ id ][ groupID ] ) ){
		
		
		new szName[ 64 ] ,
			szAllNames[ 1024 ];
		
		new iLen = 0;
		
		for( new iCurrentPlayer = 1 ; iCurrentPlayer <= MAX ; iCurrentPlayer++ ){
			if( iCurrentPlayer == id || !checkIsIn( iCurrentPlayer , userInf[ id ][ groupID ] )  ){
				continue;
			}
			
			get_user_name( iCurrentPlayer , szName , charsmax( szName ) );
			
			iLen += format( szAllNames[ iLen ] , charsmax( szAllNames ) - iLen , " %s" , szName );
		}
		
		new szTitle[ 256 ];
		
		formatex( szTitle , charsmax( szTitle ),  "\wCzy chcesz usunac grupe z \r%s \w? ", szAllNames );
			
		new pMenu = menu_create( szTitle , "removeMenuHandle" );
			
		menu_additem( pMenu , "\rUsun \wGrupe" );
			
		menu_display( id , pMenu );
		
		return PLUGIN_HANDLED;
	}
	
	new pMenu	=	menu_create( "Zapros Gracza do Grupy" , "menuHandle" );
	
	new szInfo[ 16 ] ,
	szText[ 256 ];
	
	for( new i = 1 ; i < MAX + 1 ; i++ ){
		
		if( i == id || !is_user_connected( i ) || userInf[ i ][ isInGroup ] || cs_get_user_team( i ) != CS_TEAM_CT ){
			continue;
		}
		
		get_user_name( i , szText , charsmax( szText ) );
		
		num_to_str( i , szInfo , charsmax( szInfo ) );
		
		menu_additem( pMenu , szText , szInfo );
	}
	
	menu_setprop( pMenu , MPROP_EXITNAME , "Wyjscie" );
	menu_setprop( pMenu , MPROP_BACKNAME , "Wroc" );
	menu_setprop( pMenu , MPROP_NEXTNAME , "Dalej" );
	
	menu_setprop( pMenu , MPROP_NUMBER_COLOR , "\r" );
	
	menu_display( id , pMenu );
	
	return PLUGIN_HANDLED;
}

public removeMenuHandle( id , menu , item ){
	if( item == MENU_EXIT || !userInf[ id ][ isInGroup ] || checkGroupSize( userInf[ id ][ groupID ] ) ){
		menu_destroy( menu );
		
		return PLUGIN_HANDLED;
		
	}
	
	new idFind = findGroupIDUser(userInf[ id ][  groupID ], id );
	
	clearUserInf( id );
	
	if( is_user_connected( idFind ) ){
		
		new szFirstPlayerName[ 64 ],
		szSecondPlayerName[ 64 ];
		
		get_user_name( id , szFirstPlayerName , charsmax( szFirstPlayerName ) );
		get_user_name( idFind , szSecondPlayerName , charsmax( szSecondPlayerName ) );
		
		ColorChat( id , RED , "[ GRUPY ] - ^x01Usunales Grupe z^x04 %s^x01" , szSecondPlayerName );
		ColorChat( idFind , RED , "[ GRUPY ] - ^x01Gracz^x04 %s^x01 usunal Wasza Grupe^x04" , szFirstPlayerName );
		
	}
	
	
	menu_destroy( menu );
		
	return PLUGIN_HANDLED;
}

findGroupIDUser( idGroup , idIgnore ){
	for( new i = 0 ; i < MAX + 1; i++ ){
		
		if( userInf[ i ][ groupID ] != idGroup || i == idIgnore ){
			continue;
		}
		
		return i;
	}
	
	return 0;
}

public menuHandle( id , menu , item ){
	
	if( item == MENU_EXIT ){
		
		menu_destroy( menu );
		
		return PLUGIN_HANDLED;
	}
	
	new access , szInfo[ 256 ] , szName[ 256 ] , callback;
	
	menu_item_getinfo( menu , item , access , szInfo , charsmax( szInfo ) , szName , charsmax( szName ) , callback );
	
	new idUser	=	str_to_num( szInfo );
	
	if( !is_user_connected( idUser ) ){
		
		ColorChat(id,RED,"[ GRUPY ] - ^x01Gracza nie ma^x04 na serwerze^x01" );
		
		menu_destroy( menu );
		
		return PLUGIN_HANDLED;
	}
	
	if( userInf[ idUser ][ isInGroup ] ){
		
		ColorChat(id,RED,"[ GRUPY ] - ^x01Gracz jest juz w^x04 Grupie^x01" );
		
		menu_destroy( menu );
		
		return PLUGIN_HANDLED;
		
	}
	
	if( cs_get_user_team( idUser ) != CS_TEAM_CT ){
		
		ColorChat(id,RED,"[ GRUPY ] - ^x01Gracz jest w^x04 Zombi^x01" );
		
		menu_destroy( menu );
		
		return PLUGIN_HANDLED;
	}
	
	new szText[ 256 ];
	
	num_to_str( id , szInfo , charsmax( szInfo ) )
	
	get_user_name( id , szName , charsmax( szName ) );
	
	formatex( szText , charsmax( szText ) , "\wGracz \r%s \wzaprasza Cie do Grupy \rZgadzasz Sie \w?" , szName );
	
	new pMenu	=	menu_create( szText , "menuInviteHandle" );
	
	menu_additem( pMenu , "Tak" , szInfo );
	menu_additem( pMenu , "Nie" , szInfo );
	
	menu_setprop( pMenu , MPROP_EXITNAME , "Wyjscie" );
	menu_setprop( pMenu , MPROP_PADMENU , 0 );
	
	menu_display( idUser , pMenu );
	
	menu_destroy( menu );
	
	return PLUGIN_HANDLED;
}

public menuInviteHandle( id , menu , item ){
	if( item == MENU_EXIT ||  userInf[ id ][ isInGroup ] ){
		
		menu_destroy( menu );
		
		return PLUGIN_HANDLED;
	}
	
	new access , szInfo[ 256 ] , szName[ 256 ] , callback;
	
	menu_item_getinfo( menu , item , access , szInfo , charsmax( szInfo ) , szName , charsmax( szName ) , callback );
	
	get_user_name( id , szName , charsmax( szName ) );
	
	new idUser	=	str_to_num( szInfo );
	
	if( item == 0 ){
		
		if( !is_user_connected( idUser ) ){
			
			menu_destroy( menu );
			
			return PLUGIN_HANDLED;
		}
		
		ColorChat(idUser,RED,"[ GRUPY ] - ^x01Gracz^x04 %s^x01 przyjal^x04 Twoje zaproszenie^x01" , szName );
		
		if( userInf[ idUser ][ isInGroup ] ){
			
			if( !checkGroupSize( userInf[ idUser ][ groupID ] ) ){
				
				menu_destroy( menu );
				
				return PLUGIN_HANDLED;
				
			}
			
			userInf[ id ][ isInGroup ]	=	true;
			userInf[ id ][ groupID ]	=	userInf[ idUser ][ groupID ];
			userInf[ id ][ groupColor ] = 	userInf[ idUser ][ groupColor ];
			
			new iColor = userInf[ idUser ][ groupColor ];
			
			set_user_rendering( id , kRenderFxGlowShell , colorRGB[ iColor ][ 0 ] , colorRGB[ iColor ][ 1 ] , colorRGB[ iColor ][ 2 ] , kRenderNormal , amountRender );
			
			ColorChat(id,RED,"[ GRUPY ] - ^x01 Kolor waszej Grupy to:^x04 %s^x01" , colorNames[ iColor ] );
			
		}
		else{
			
			new group = findGroup();
			
			if( group == -1 ){
				
				menu_destroy( menu );
				
				return PLUGIN_HANDLED;
			}
			
			new iColor = currentColor++;
			
			if( iColor >= sizeof colorNames ){
				iColor = sizeof colorNames - 1
				currentColor = sizeof colorNames - 1;
			}
			
			userInf[ id ][ isInGroup ]	=	true;
			userInf[ id ][ groupID ]	=	group;
			userInf[ id ][ groupColor ] = 	iColor;
			
			userInf[ idUser ][ isInGroup ]	=	true;
			userInf[ idUser ][ groupID ]	=	group;
			userInf[ idUser ][ groupColor ] = 	iColor;
			
			set_user_rendering( id , kRenderFxGlowShell , colorRGB[ iColor ][ 0 ] , colorRGB[ iColor ][ 1 ] , colorRGB[ iColor ][ 2 ] , kRenderNormal , amountRender );
			set_user_rendering( idUser , kRenderFxGlowShell , colorRGB[ iColor ][ 0 ] , colorRGB[ iColor ][ 1 ] , colorRGB[ iColor ][ 2 ] , kRenderNormal , amountRender );
			
			ColorChat(id,RED,"[ GRUPY ] - ^x01 Kolor waszej Grupy to:^x04 %s^x01" , colorNames[ iColor ] );
			ColorChat(idUser,RED,"[ GRUPY ] - ^x01 Kolor waszej Grupy to:^x04 %s^x01" , colorNames[ iColor ] );
			
			setGroupUsed( group );
		}
	}
	else{
		ColorChat(idUser,RED,"[ GRUPY ] - ^x01Gracz^x04 %s^x01 nie przyjal^x04 Twojego zaproszenia^x01" , szName );
	}
	
	menu_destroy( menu );
	
	return PLUGIN_HANDLED;
}

public clearUserInf( id ){
	
	if( !userInf[ id ][ isInGroup ] ){
		return;
	}
	
	new idGroup	=	userInf[ id ][ groupID ];
	
	userInf[ id ][ isInGroup ]	=	false;
	userInf[ id ][ groupID ]	=	-1;
	userInf[ id ][ groupColor ]	=	-1;
	
	set_user_rendering( id , kRenderFxNone , 255 , 255 , 255 , kRenderNormal , 255 );
	
	if( countGroup( idGroup ) <= 1 ){
		removeGroup( idGroup );
	}
	
	checkGroup( idGroup );
}

countGroup( idGroup ){
	new iAmount = 0;
	
	for( new i = 0 ; i < MAX + 1; i++ ){
		
		if( userInf[ i ][ groupID ] != idGroup ){
			continue;
		}
		
		iAmount++;
		
	}
	
	return iAmount;
}

removeGroup( idGroup ){
	for( new i = 0 ; i < MAX + 1; i++ ){
		
		if( userInf[ i ][ groupID ] != idGroup ){
			continue;
		}
		
		userInf[ i ][ isInGroup ]	=	false;
		userInf[ i ][ groupID ]		=	-1;
		userInf[ i ][ groupColor ]	=	-1;
		
		set_user_rendering( i , kRenderFxNone , 255 , 255 , 255 , kRenderNormal , 255 );
		
	}
	
	groupUsed[ idGroup ]	=	false;
	
	currentColor--;
	
	if( currentColor < 0 ){
		currentColor = 0;
	}
}

public checkGroup( idGroup ){
	
	new bool: isUsed = false;
	
	for( new i = 0 ; i < MAX + 1; i++ ){
		
		if( userInf[ i ][ groupID ] != idGroup ){
			continue;
		}
		
		isUsed	=	true;
		
		break;
		
	}
	
	groupUsed[ idGroup ]	=	isUsed;
	
}

public findGroup(){
	
	for( new i = 0 ; i < MAX + 1; i++ ){
		
		if( groupUsed[ i ] ){
			continue;
		}
		
		return i;
		
	}
	
	return -1;
}

public setGroupUsed( idGroup ){
	groupUsed[ idGroup ]	=	true;
}

public bool:checkGroupSize( idGroup ){
	
	new iNumber	=	0;
	
	for( new i = 0 ; i < MAX + 1; i++ ){
		
		if( userInf[ i ][ groupID ] != idGroup ){
			continue;
		}
		
		iNumber++;
		
	}
	
	return ( iNumber < get_pcvar_num( pCvarMAX ) );
}

public bb_prepphase_started(){
	new iEnt	=	-1 ,
	szTarget[ 128 ];
	
	while( ( iEnt = engfunc( EngFunc_FindEntityByString , iEnt , "classname" , "func_wall" ) ) != 0 ){
		
		pev( iEnt , pev_targetname , szTarget , charsmax( szTarget ) );
		
		if( equal( szTarget , "ignore" ) || bb_is_used_block( iEnt ) || equal( szTarget , "barrier" ) ){
			continue;
		}
		
		engfunc( EngFunc_SetOrigin , iEnt , { 9999.0 , 9999.0 , 9999.0 } );
	}
	
	bSlap = true;
}

public bool:bb_is_used_block( iEnt ){
	return bool:pev( iEnt , pev_iuser4 );
}

public DeathMsg(){
	
	new vid = read_data( 2 );
	
	if( !bb_is_user_zombie( vid ) ){
		checkBlocks( vid );
		
		if( userInf[ vid ][ isInGroup ] ){
			for( new iPlayer = 1 ; iPlayer <= MAX ; iPlayer++ ){
				if( !is_user_connected( iPlayer ) || !userInf[ iPlayer ][ isInGroup ] || userInf[ vid ][ groupID ] != userInf[ iPlayer ][ groupID ] ){
					continue;
				}
				
				set_user_rendering( iPlayer , kRenderFxNone , 255 , 255 , 255 , kRenderNormal , 16 );
			}
		}
	}	
}

public checkBlocks( vid ){
	new iEnt	=	-1 ,
	szTarget[ 128 ];
	
	if( userInf[ vid ][ isInGroup ] ){
		if( !checkGroupAlive( userInf[ vid ][ groupID ] ) ){
			
			while( ( iEnt = engfunc( EngFunc_FindEntityByString , iEnt , "classname" , "func_wall" ) ) != 0 ){
				
				pev( iEnt , pev_targetname , szTarget , charsmax( szTarget ) );
				
				if( equal( szTarget , "ignore" ) || !bb_is_used_block( iEnt ) || equal( szTarget , "barrier" ) ){
					continue;
				}
				
				new idUser	=	pev( iEnt , pev_iuser4 );
				
				if( !checkIsIn( idUser , userInf[ vid ][ groupID ] ) ){
					continue;
				}
				
				engfunc( EngFunc_SetOrigin , iEnt , { 9999.0 , 9999.0 , 9999.0 } );
			}
			
		}
	}
	else{
		while( ( iEnt = engfunc( EngFunc_FindEntityByString , iEnt , "classname" , "func_wall" ) ) != 0 ){
			
			pev( iEnt , pev_targetname , szTarget , charsmax( szTarget ) );
			
			if( equal( szTarget , "ignore" ) || pev( iEnt , pev_iuser4 ) != vid || equal( szTarget , "barrier" ) ){
				continue;
			}
			
			engfunc( EngFunc_SetOrigin , iEnt , { 9999.0 , 9999.0 , 9999.0 } );
		}
	}
}

public bool: checkGroupAlive( idGroup ){
	
	for( new i = 1; i < MAX + 1 ; i++ ){
		
		if( !userInf[ i ][ isInGroup ] || userInf[ i ][ groupID ] != idGroup || !is_user_alive( i ) || bb_is_user_zombie( i ) ){
			continue;
		}
		
		return true;
		
	}
	
	return false;
	
}

public bool: checkIsIn( id , idGroup ){
	
	if( !userInf[ id ][ isInGroup ] ){
		return false;
	}
	
	return userInf[ id ][ groupID ] == idGroup;
}

public bool:checkAmountPlayer( iAmount ){
	new iAmountPlayers = 0;
	
	for( new iCurrent = 1 ; iCurrent < 33 ; iCurrent++ ){
		if( !is_user_connected( iCurrent ) || is_user_hltv( iCurrent ) ){
			continue;
		}
		
		iAmountPlayers++;
	}
	
	return iAmountPlayers >= iAmount;
}

public bb_grab_post(id,ent){
	if(get_pcvar_num(pAdmin) && get_user_flags(id)&FLAG && !bBuild ){
		return PLUGIN_CONTINUE;
	}
	
	if(pev(ent,pev_iuser4) != id && pev(ent,pev_iuser4) != 0){		
		new iLast = pev(ent,pev_iuser4);
		
		if( checkIsIn( id , userInf[ iLast ][ groupID ] ) ){
			return PLUGIN_CONTINUE;
		}
		
		bb_drop_user_block(id);
		SetLastMover(ent,iLast);
		
		if(get_pcvar_num(pInfo)){
			static szText[128],szName[64]
			get_pcvar_string(pInfoText,szText,charsmax(szText));
			get_user_name(iLast,szName,charsmax(szName));
			replace_all(szText,charsmax(szText),"%s",szName);
			client_print(id,print_center,szText);
		}
	}
	
	return PLUGIN_CONTINUE;
}
