#include <amxmodx>
#include <hamsandwich>
#include <engine>
#include <zombieplague>
#include <fun>
#include <fakemeta_util>
#include <zombiemod>

#define PLUGINNAME        "[ZP] Extra Item: Dynamite Zombie"
#define VERSION           "0.1"
#define AUTHOR            "Zombie-rus"

native bool:isRoundEnd();
native bool:getMask( id );

new const sprite_grenade_ring[] = "sprites/shockwave.spr"

new g_dynam,
spr_smoke_steam1,cvar_damage_radius;
new bool:lamuerteexplosiva[33] = false

new g_icon[33][16], g_status
new g_msgSayText

new const beep_sound [ ] = "weapons/c4_beep5.wav"
new spr_zerogxplode,g_exploSpr;

new g_msgDeathMsg, g_msgScoreAttrib,g_msgScoreInfo;

public plugin_init()
{  
	register_plugin(PLUGINNAME, VERSION, AUTHOR)
	
	cvar_damage_radius = register_cvar("zp_boomer_raius","5000")
	
	register_event("DeathMsg", "boomer_death", "a")
	register_event("HLTV", "NewRound", "a", "1=0", "2=0")
	
	g_msgSayText = get_user_msgid("SayText")
	
	g_msgDeathMsg = get_user_msgid("DeathMsg")
	g_msgScoreAttrib = get_user_msgid("ScoreAttrib")
	g_msgScoreInfo = get_user_msgid("ScoreInfo");
	
	g_status = get_user_msgid("StatusIcon")
}
public plugin_precache() 
{
	g_dynam = zp_register_extra_item("Autodestrukcja", 100, ZP_TEAM_ZOMBIE)  
	precache_sound ( beep_sound )
	precache_sound("weapons/mortarhit.wav")
	
	g_exploSpr = engfunc(EngFunc_PrecacheModel, sprite_grenade_ring)
}
public zp_extra_item_selected(player, itemid)
{
	if (itemid == g_dynam)
	{
		lamuerteexplosiva[player] = true
		fm_set_rendering(player, kRenderFxGlowShell, 255, 0, 0, kRenderNormal, 16);
		//Play beep c4 sound
		client_cmd ( player, "spk %s", beep_sound )
		chat_color(player,"!g[ZM] !yKupiles autodestrukcje. Gdy zginiesz, caly swiat ulegnie zniszczeniu!");
		
		//Added Icon
		set_icon(player)
	}
}

public zp_user_humanized_post(player)
{
	lamuerteexplosiva[player] = false
}

public NewRound(i)
{
	for (i = 1; i <= 32; i++)
		lamuerteexplosiva[i] = false
}

public boomClear( victim ){
if (lamuerteexplosiva[victim])
	{
		
		new Float:origin[3], origin2[3]
		entity_get_vector(victim,EV_VEC_origin,origin)
		
		origin2[0] = floatround(origin[0])
		origin2[1] = floatround(origin[1])
		origin2[2] = floatround(origin[2]) 
		
		
		emit_sound(victim, CHAN_WEAPON, "weapons/mortarhit.wav", 1.0, 0.5, 0, PITCH_NORM)
		emit_sound(victim, CHAN_VOICE, "weapons/mortarhit.wav", 1.0, 0.5, 0, PITCH_NORM) 
		
		create_blast( origin )
		
		for (new e = 1; e < 8; e++)
		{
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_SPRITE)
			write_coord(origin2[0] + random_num(-60,60))
			write_coord(origin2[1] + random_num(-60,60))
			write_coord(origin2[2] +128)
			write_short(spr_zerogxplode)
			write_byte(random_num(30,65))
			write_byte(255)
			message_end()
		}
		
		for (new e = 1; e < 3; e++)
		{
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_SMOKE)
			write_coord(origin2[0])
			write_coord(origin2[1])
			write_coord(origin2[2] + 256)
			write_short(spr_smoke_steam1)
			write_byte(random_num(80,150))
			write_byte(random_num(5,10))
			message_end()
		}
		
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_GUNSHOTDECAL)
		write_coord(origin2[0])
		write_coord(origin2[1])
		write_coord(origin2[2])
		write_short(0)                  
		write_byte(random_num(46,48))  // decal
		message_end()
		
	}
}

public boom( victim ){
	if (lamuerteexplosiva[victim])
	{
		
		new Float:origin[3], origin2[3]
		entity_get_vector(victim,EV_VEC_origin,origin)
		
		origin2[0] = floatround(origin[0])
		origin2[1] = floatround(origin[1])
		origin2[2] = floatround(origin[2]) 
		
		
		emit_sound(victim, CHAN_WEAPON, "weapons/mortarhit.wav", 1.0, 0.5, 0, PITCH_NORM)
		emit_sound(victim, CHAN_VOICE, "weapons/mortarhit.wav", 1.0, 0.5, 0, PITCH_NORM) 
		
		create_blast( origin )
		
		for (new e = 1; e < 8; e++)
		{
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_SPRITE)
			write_coord(origin2[0] + random_num(-60,60))
			write_coord(origin2[1] + random_num(-60,60))
			write_coord(origin2[2] +128)
			write_short(spr_zerogxplode)
			write_byte(random_num(30,65))
			write_byte(255)
			message_end()
		}
		
		for (new e = 1; e < 3; e++)
		{
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_SMOKE)
			write_coord(origin2[0])
			write_coord(origin2[1])
			write_coord(origin2[2] + 256)
			write_short(spr_smoke_steam1)
			write_byte(random_num(80,150))
			write_byte(random_num(5,10))
			message_end()
		}
		
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_GUNSHOTDECAL)
		write_coord(origin2[0])
		write_coord(origin2[1])
		write_coord(origin2[2])
		write_short(0)                  
		write_byte(random_num(46,48))  // decal
		message_end()
		
		
		new Damage_Radius = get_pcvar_num(cvar_damage_radius)  
		new PlayerPos[3], Distance;
		
		
		for (new i = 1; i < 32; i++)
		{
			if (is_user_alive(i) && i != victim && !zp_get_user_zombie( i ) && !getMask( i ) )
			{
				get_user_origin(i, PlayerPos)
				
				Distance = get_distance(PlayerPos, origin2)
				
				if (Distance <= Damage_Radius) {
					
					message_begin(MSG_ONE, get_user_msgid("ScreenShake"), {0,0,0}, i)
					write_short(1<<14)
					write_short(1<<14)
					write_short(1<<14)
					message_end()
					
					if( zp_get_user_last_human( i ) ){
						ExecuteHamB( Ham_Killed, i, victim , 0)
					}
					else{
						zp_infect_user( i , victim , 0 , 0 );
						
						SendDeathMsg( victim, i )
						FixDeadAttrib( i )
						
						UpdateFrags( victim, i, 1, 1, 1)
					}
				}
			}
		}
		
	}
}

public boomer_death() 
{ 
	new attacker = read_data(1)
	new victim = read_data(2)
	
	if ( isRoundEnd() ) return;
	
	if( zp_get_user_last_zombie( victim ) ){
		set_task( 0.1 , "boomClear" , victim );
	}
	else{
		set_task( 0.1 , "boom" , victim );
	}
}

public create_blast(const Float:originF[3])
{
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_BEAMCYLINDER) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	engfunc(EngFunc_WriteCoord, originF[0]) // x axis
	engfunc(EngFunc_WriteCoord, originF[1]) // y axis
	engfunc(EngFunc_WriteCoord, originF[2]+385.0) // z axis
	write_short(g_exploSpr) // sprite
	write_byte(0) // startframe
	write_byte(0) // framerate
	write_byte(4) // life
	write_byte(60) // width
	write_byte(0) // noise
	write_byte(255) // red
	write_byte(128) // green
	write_byte(0) // blue
	write_byte(200) // brightness
	write_byte(0) // speed
	message_end()
	
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_BEAMCYLINDER) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	engfunc(EngFunc_WriteCoord, originF[0]) // x axis
	engfunc(EngFunc_WriteCoord, originF[1]) // y axis
	engfunc(EngFunc_WriteCoord, originF[2]+470.0) // z axis
	write_short(g_exploSpr) // sprite
	write_byte(0) // startframe
	write_byte(0) // framerate
	write_byte(4) // life
	write_byte(60) // width
	write_byte(0) // noise
	write_byte(255) // red
	write_byte(164) // green
	write_byte(0) // blue
	write_byte(200) // brightness
	write_byte(0) // speed
	message_end()
	
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_BEAMCYLINDER) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	engfunc(EngFunc_WriteCoord, originF[0]) // x axis
	engfunc(EngFunc_WriteCoord, originF[1]) // y axis
	engfunc(EngFunc_WriteCoord, originF[2]+555.0) // z axis
	write_short(g_exploSpr) // sprite
	write_byte(0) // startframe
	write_byte(0) // framerate
	write_byte(4) // life
	write_byte(60) // width
	write_byte(0) // noise
	write_byte(255) // red
	write_byte(200) // green
	write_byte(0) // blue
	write_byte(200) // brightness
	write_byte(0) // speed
	message_end()
}


public client_disconnect(id) 
{
	lamuerteexplosiva[id] = false
}  

public client_putinserver(id) 
{
	lamuerteexplosiva[id] = false
}  


stock chat_color(const id, const input[], any:...)
{
	static msg[191]
	vformat(msg, 190, input, 3)
	
	replace_all(msg, 190, "!g", "^4")
	replace_all(msg, 190, "!y", "^1")
	replace_all(msg, 190, "!t", "^3")
	replace_all(msg, 190, "!c", "^0")
	
	message_begin(MSG_ONE_UNRELIABLE, g_msgSayText, _, id)
	write_byte(id)
	write_string(msg)
	message_end()
}

public set_icon(player)
{
	static color[3], sprite[16]
	color = {255, 0, 0}
	sprite = "dmg_rad"
	g_icon[player] = sprite
	
	message_begin(MSG_ONE, g_status, {0, 0, 0}, player)
	write_byte(1)
	write_string(g_icon[player])
	write_byte(color[0])
	write_byte(color[1])
	write_byte(color[2])
	message_end()
}


public SendDeathMsg(attacker, victim)
{
	message_begin(MSG_BROADCAST, g_msgDeathMsg)
	write_byte(attacker) // killer
	write_byte(victim) // victim
	write_byte(1) // headshot flag
	write_string("grenade") // killer's weapon
	message_end()
}

public FixDeadAttrib(id)
{
	message_begin(MSG_BROADCAST, g_msgScoreAttrib)
	write_byte(id) // id
	write_byte(0) // attrib
	message_end()
}


public UpdateFrags(attacker, victim, frags, deaths, scoreboard)
{
	set_pev(attacker, pev_frags, float(pev(attacker, pev_frags) + frags))
	
	fm_set_user_deaths(victim, fm_get_user_deaths(victim) + deaths)
	
	if (scoreboard)
	{	
		message_begin(MSG_BROADCAST, g_msgScoreInfo)
		write_byte(attacker) // id
		write_short(pev(attacker, pev_frags)) // frags
		write_short(fm_get_user_deaths(attacker)) // deaths
		write_short(0) // class?
		write_short(fm_get_user_team(attacker)) // team
		message_end()
		
		message_begin(MSG_BROADCAST, g_msgScoreInfo)
		write_byte(victim) // id
		write_short(pev(victim, pev_frags)) // frags
		write_short(fm_get_user_deaths(victim)) // deaths
		write_short(0) // class?
		write_short(fm_get_user_team(victim)) // team
		message_end()
	}
}

stock fm_set_user_deaths(id, value)
{
	set_pdata_int(id, 444, value, 5)
}

stock fm_get_user_deaths(id)
{
	return get_pdata_int(id, 444, 5)
}


stock fm_get_user_team(id)
{
	return get_pdata_int(id, 114, 5)
}
